(
	fn dnClr n = ((dotNetClass "System.Drawing.Color").FromArgb n[1] n[2] n[3])
	AEI_backcolor = dnClr ((colorMan.getColor #background )*255)
	local version = 0,posi
	if findString (sysinfo.getLanguage() as string) "chinese" > 0 then
		version = 1
	local newthread = dotNetObject "CSharpUtilities.SynchronizingBackgroundWorker"
	rollout AEI_ToolBar_install_Rollout ""
	(
		dotNetControl AEI_ToolBar_install_title_btn "label" width:200 height:20 pos:[50,3]
		dotNetControl AEI_ToolBar_install_close_btn "label" width:15 height:15 pos:[281,4]
		dotNetControl AEI_ToolBar_install_startupcheck "Button"  width:138 height:22 pos:[10,24]
		dotNetControl AEI_ToolBar_install_opencheck "Button"  width:138 height:22 pos:[152,24]
		dotNetControl AEI_ToolBar_install_install_btn "Button"  width:138 height:22 pos:[10,48]
		dotNetControl AEI_ToolBar_install_uninstall_btn "Button"  width:138 height:22 pos:[152,48]
		dotNetControl AEI_ToolBar_install_label_btn "label" width:280 height:124 pos:[10,74]
		dotNetControl AEI_ToolBar_install_language_btn "Button" width:280 height:22 pos:[10,200]
		dotNetControl AEI_ToolBar_install_connect_btn "label" width:200 height:16 pos:[10,226]
		dotNetControl AEI_ToolBar_install_link_btn "label" width:74 height:16 pos:[216,226]
		groupbox AEI_ToolBar_install_groupbox "" pos:[2,-4] width:296 height:248
		fn AEI_ToolBar_install_changelanguage_fn =
		(
			if version == 1 then
			(
				AEI_ToolBar_install_title_btn.text = "AEI工具栏安装 v2.0.0"
				AEI_ToolBar_install_startupcheck.text = "☑ 随软件启动"
				AEI_ToolBar_install_opencheck.text = "☐ 完成后打开路径"
				AEI_ToolBar_install_install_btn.text = "安装"
				AEI_ToolBar_install_uninstall_btn.text = "卸载"
				AEI_ToolBar_install_label_btn.text = "安装说明：\n1、开启随软件启动时，程序将自动在Startup文件夹创建启动文件，脚本将在Max启动时运行。\n2、如需要在安装后将已有脚本移入工具栏所在文件夹，请选中“完成后打开路径”按钮，或使用右键点击按钮。\n3、点击安装按钮后，请等待按钮文字变成“安装完成”时完成安装过程，此时可关闭此窗口，开始使用AEI工具栏吧。"
				AEI_ToolBar_install_connect_btn.text =  "未连接到官方网站"
				AEI_ToolBar_install_language_btn.text = "Click here change to English language"
			)
			else
			(
				AEI_ToolBar_install_title_btn.text = "Installer of AEI_ToolBar v2.0.0"
				AEI_ToolBar_install_startupcheck.text = "☑ Startup with Max"
				AEI_ToolBar_install_opencheck.text = "☐ Open path at end"
				AEI_ToolBar_install_install_btn.text = "Install"
				AEI_ToolBar_install_uninstall_btn.text = "Uninstall"
				AEI_ToolBar_install_label_btn.text = "Instructions:\n1、If you need run the toolbar with Max startup , check the first button .\n2、If you need copy scripts to the path of toolbar , check the second button or right click it .\n3、When installing , please wait until the text of install button to be 'Installation is complete' .\n\nEnjoy the script and changing useges of work ."
				AEI_ToolBar_install_connect_btn.text = "Disconnected to the official website"
				AEI_ToolBar_install_language_btn.text = "切 换 为 中 文"
			)
		)
		fn AEI_ToolBar_install_connectaei_getvision =
	   	(
			try
			(
				local response = (dotnetObject "System.Net.WebClient").DownloadString "http://www.aei.pub/list/subpage/aei001/version.html"
				if version == 1 then
					AEI_ToolBar_install_connect_btn.text = "当前最新版本为："+response
					else
					AEI_ToolBar_install_connect_btn.text = "Newest vision : "+response
				AEI_ToolBar_install_connect_btn.forecolor = dnClr [255,228,181]
				dotNet.removeAllEventHandlers newthread
			)catch()
	   	)
		on AEI_ToolBar_install_language_btn click do
		(
			if version == 0 then version = 1 else version  = 0
			AEI_ToolBar_install_changelanguage_fn ()
			dotnet.addEventHandler newthread "DoWork" AEI_ToolBar_install_connectaei_getvision
			newthread.runworkerasync()
		)
		fn getFilesRecursive root pattern =
		(
			dir_array = GetDirectories (root+"/*")
			for d in dir_array do
			  join dir_array (GetDirectories (d+"/*"))
			append dir_array (root+"\\")
			my_files = #()
			for f in dir_array do
			  join my_files (getFiles (f + pattern))
			my_files
		)
		fn AEI_ToolBar_install_fn =
		(
			if version == 1 then
				AEI_ToolBar_install_install_btn.text = "安装中"
				else
					AEI_ToolBar_install_install_btn.text = "Installing"
			for i in getDirectories (sysInfo.tempdir + "mzptmp*") do
			(
				if (getDirectories (i+"AEI_ToolBar")).count > 0 do
				(
					for o in getFilesRecursive (i+"AEI_ToolBar") "*.*" do
					(
						if (getDirectories (getFilenamePath (GetDir #scripts + "\\AEI\\AEI_ToolBar\\" + substring o ((i+"AEI_ToolBar").count+1) -1))).count == 0 do
							makeDir (getFilenamePath (GetDir #scripts + "\\AEI\\AEI_ToolBar\\" + substring o ((i+"\\AEI_ToolBar").count+1) -1)) all:true
						copyFile o (GetDir #scripts + "\\AEI\\AEI_ToolBar\\" + (substring o ((i+"AEI_ToolBar").count+1) -1))
					)
					if findstring AEI_ToolBar_install_startupcheck.text "☑" != undefined do
						copyFile (i+"\\AEI_ToolBar_run.ms") (GetDir #scripts + "\\Startup\\AEI_ToolBar_run.ms")
					exit
				)
			)
			if version == 1 then
				AEI_ToolBar_install_install_btn.text = "安装完成"
				else
					AEI_ToolBar_install_install_btn.text = "Installation is complete"
			filein (GetDir #scripts + "\\AEI\\AEI_ToolBar\\AEI_ToolBar.mse")
		)
		fn AEI_ToolBar_uninstall_fn =
		(
			if version == 1 then
				AEI_ToolBar_install_uninstall_btn.text = "卸载中"
				else
					AEI_ToolBar_install_uninstall_btn.text = "Uninstalling"
			HiddenDOSCommand ("rmdir /s/q \""+ GetDir #scripts + "\\AEI\\AEI_ToolBar\"")
			HiddenDOSCommand ("del /f /a /q \""+ GetDir #scripts + "\\Startup\\AEI_ToolBar_run.ms\"")
			if AEI_Rollout != undefined do
			(
				try
					cui.UnRegisterDialogBar AEI_Rollout
					catch()
				try 
					DestroyDialog AEI_Rollout
					catch()
			)
			setFocus AEI_ToolBar_install_Rollout
			if version == 1 then
				AEI_ToolBar_install_Rollout.AEI_ToolBar_install_uninstall_btn.text = "卸载完成"
				else
					AEI_ToolBar_install_Rollout.AEI_ToolBar_install_uninstall_btn.text = "Uninstallation is complete"
		)
		on AEI_ToolBar_install_install_btn click do
		(
			AEI_ToolBar_install_fn ()
		)
		on AEI_ToolBar_install_uninstall_btn click do
		(
			AEI_ToolBar_uninstall_fn ()
		)
		on AEI_ToolBar_install_startupcheck Click do
		(
			if version == 1 then
				if AEI_ToolBar_install_startupcheck.text == "☑ 随软件启动" then AEI_ToolBar_install_startupcheck.text = "☐ 随软件启动"
					else AEI_ToolBar_install_startupcheck.text = "☑ 随软件启动"
				else
					if AEI_ToolBar_install_startupcheck.text == "☑ Startup with Max" then AEI_ToolBar_install_startupcheck.text = "☐ Startup with Max"
						else AEI_ToolBar_install_startupcheck.text = "☑ Startup with Max"
		)
		on AEI_ToolBar_install_opencheck mouseup s e do
		(
			if e.button == e.button.left then
				if version == 1 then
					if AEI_ToolBar_install_opencheck.text == "☑ 完成后打开路径" then AEI_ToolBar_install_opencheck.text = "☐ 完成后打开路径"
						else AEI_ToolBar_install_opencheck.text = "☑ 完成后打开路径"
					else
						if AEI_ToolBar_install_opencheck.text == "☑ Open path at end" then AEI_ToolBar_install_opencheck.text = "☐ Open path at end"
							else AEI_ToolBar_install_opencheck.text = "☑ Open path at end"
			else
				shellLaunch (GetDir #scripts + "\\AEI\\AEI_ToolBar") ""
		)
		on AEI_ToolBar_install_link_btn MouseEnter e do 
		(
			AEI_ToolBar_install_link_btn.forecolor = dnClr [255,140,35] 
		)
		on AEI_ToolBar_install_link_btn MouseLeave e do 
		(
			AEI_ToolBar_install_link_btn.forecolor = dnClr [0,0,0]
		)
		on AEI_ToolBar_install_link_btn Click do
		(
			shellLaunch "http://aei.pub/" "" 
		)
		on AEI_ToolBar_install_connect_btn Click do
		(
			if version == 1 then
				shellLaunch "http://www.aei.pub/list/subpage/aei001/chs.html" "" 
				else
				shellLaunch "http://www.aei.pub/list/subpage/aei001/enu.html" "" 
		)
		on AEI_ToolBar_install_title_btn MouseDown e do
		(
			posi = mouse.screenpos - getDialogPos AEI_ToolBar_install_Rollout
		)
		on AEI_ToolBar_install_title_btn Mousemove e do 
		if (e.Button == e.Button.Left) then
		(
			SetDialogPos AEI_ToolBar_install_Rollout (mouse.screenpos -  posi)
		)
		on AEI_ToolBar_install_close_btn click do
			destroydialog AEI_ToolBar_install_Rollout
		on AEI_ToolBar_install_Rollout open do
		(
			AEI_ToolBar_install_title_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_startupcheck.backcolor = AEI_backcolor
			AEI_ToolBar_install_opencheck.backcolor = AEI_backcolor
			AEI_ToolBar_install_startupcheck.FlatStyle = AEI_ToolBar_install_startupcheck.FlatStyle.Flat
			AEI_ToolBar_install_startupcheck.FlatAppearance.BorderSize = 1
			AEI_ToolBar_install_opencheck.FlatStyle = AEI_ToolBar_install_opencheck.FlatStyle.Flat
			AEI_ToolBar_install_opencheck.FlatAppearance.BorderSize = 1
			AEI_ToolBar_install_install_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_uninstall_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_install_btn.FlatStyle = AEI_ToolBar_install_install_btn.FlatStyle.Flat
			AEI_ToolBar_install_install_btn.FlatAppearance.BorderSize = 1
			AEI_ToolBar_install_uninstall_btn.FlatStyle = AEI_ToolBar_install_uninstall_btn.FlatStyle.Flat
			AEI_ToolBar_install_uninstall_btn.FlatAppearance.BorderSize = 1
			AEI_ToolBar_install_label_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_connect_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_link_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_language_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_language_btn.FlatStyle=AEI_ToolBar_install_language_btn.FlatStyle.Flat
			AEI_ToolBar_install_language_btn.FlatAppearance.BorderSize = 1
			AEI_ToolBar_install_changelanguage_fn ()
			AEI_ToolBar_install_title_btn.TextAlign = AEI_ToolBar_install_title_btn.TextAlign.MiddleCenter
			AEI_ToolBar_install_close_btn.backcolor = AEI_backcolor
			AEI_ToolBar_install_close_btn.text = "✗"
			AEI_ToolBar_install_close_btn.TextAlign = AEI_ToolBar_install_close_btn.TextAlign.BottomLeft
			AEI_ToolBar_install_close_btn.AutoSize = false
			AEI_ToolBar_install_close_btn.font = dotnetobject "System.Drawing.Font" "Arial" 10
			AEI_ToolBar_install_link_btn.text = "www.AEI.pub"
			dotnet.addEventHandler newthread "DoWork" AEI_ToolBar_install_connectaei_getvision
			newthread.runworkerasync()
		)
		on AEI_ToolBar_install_Rollout close do
			for i in getDirectories (sysInfo.tempdir + "mzptmp*") do
			(
				if (getDirectories (i+"AEI_ToolBar")).count > 0 do
				(
					HiddenDOSCommand ("rmdir /s/q "+ i)
					exit
				)
			)
	)
	createdialog AEI_ToolBar_install_Rollout 300 246 style:#()
)